#include "OdometryCalcClass.h"
#define _USE_MATH_DEFINES
#include <math.h>

#include "stdio.h"
double ROBOT::POSE::GetInitPositionX(){
	return this->InitX;
}

double ROBOT::POSE::GetInitPositionY(){
	return this->InitY;
}

double ROBOT::POSE::GetInitTheta(){
	return this->InitTheta;
}

void ROBOT::POSE::GetInitPose(double *x, double *y, double *theta){//RtBM[V̒lԂ
	*x = this->GetInitPositionX();
	*y = this->GetInitPositionY();
	*theta = this->GetInitTheta();
}

double ROBOT::POSE::GetPositionX(){
	return this->x;
}

double ROBOT::POSE::GetPositionY(){
	return this->y;
}

double ROBOT::POSE::GetTheta(){
	return this->theta;
}

void ROBOT::POSE::GetPose(double *x, double *y, double *theta){//RtBM[V̒lԂ
	*x = this->GetPositionX();
	*y = this->GetPositionY();
	*theta = this->GetTheta();
}

void ROBOT::POSE::SetPositionX(double x){
	this->x = x;
}

void ROBOT::POSE::SetPositionY(double y){
	this->y = y;
}

void ROBOT::POSE::SetTheta(double theta){
	this->theta = theta;
}

void ROBOT::POSE::SetPose(double x, double y, double theta){
	SetPositionX(x);
	SetPositionY(y);
	SetTheta(theta);
}

void ROBOT::POSE::SetInitPositionX(double x){
	this->InitX = x;
}

void ROBOT::POSE::SetInitPositionY(double y){
	this->InitY = y;
}

void ROBOT::POSE::SetInitTheta(double theta){
	this->InitTheta = theta;
}

void ROBOT::POSE::SetInitPose(double x, double y, double theta){
	SetInitPositionX(x);
	SetInitPositionY(y);
	SetInitTheta(theta);
}



void ROBOT::VELOCITY::SetReceiveVelocityVl(double vl){
	this->receive_vl = vl;
}

void ROBOT::VELOCITY::SetReceiveVelocityVr(double vr){
	this->receive_vr = vr;
}

void ROBOT::VELOCITY::SetReceiveVelocity(double vl, double vr){
	this->SetReceiveVelocityVl(vl);
	this->SetReceiveVelocityVr(vr);
}

void ROBOT::VELOCITY::SetVelocityVl(double vl_now){
	this->vl_now = vl_now;
}

void ROBOT::VELOCITY::SetVelocityVr(double vr_now){
	this->vr_now = vr_now;
}

void ROBOT::VELOCITY::SetVelocity(double vl_now, double vr_now){
	SetVelocityVl(vl_now);
	SetVelocityVr(vr_now);
}

void ROBOT::VELOCITY::SetVelocityV(double v){
	this->v_now = v;
}

void ROBOT::VELOCITY::SetVelocityW(double w){
	this->w_now = w;
}

double ROBOT::VELOCITY::GetVelocityVl(void){
	return this->vl_now;
}

double ROBOT::VELOCITY::GetVelocityVr(void){
	return this->vr_now;
}

void ROBOT::VELOCITY::GetVelocity(double *vl_now, double *vr_now){
	*vl_now = this->GetVelocityVl();
	*vr_now = this->GetVelocityVr();
}

double ROBOT::VELOCITY::GetVelocityV(void){
	return this->v_now;
}
double ROBOT::VELOCITY::GetVelocityW(void){
	return this->w_now;
}

double ROBOT::VELOCITY::GetReceiveVelocityVl(void){
	return this->receive_vl;
}

double ROBOT::VELOCITY::GetReceiveVelocityVr(void){
	return this->receive_vr;
}

void ROBOT::VELOCITY::GetReceiveVelocity(double *receive_vl, double *receive_vr){
	*receive_vl = this->GetReceiveVelocityVl();
	*receive_vr = this->GetReceiveVelocityVr();
}



void ROBOT::ODOMETRY::ConvertVWtoVLVR(double velocity /*(mm/sec)*/, double omega /*(rad/sec)*/){
	double vl, vr;
	/* Mv, wvl, vrɕϊ */
	double tmp = omega*tread/2.;
	vl = velocity - tmp;
	vr = velocity + tmp;
	/* {bg̃Rg[lXV */
	SetReceiveVelocity(vl, vr);
}

void ROBOT::ODOMETRY::ConvertVLVRtoVW(void){
	double vl, vr;
	GetVelocity(&vl, &vr);
	SetVelocityV((vl + vr)/2.);
	SetVelocityW((vr - vl)/tread);
}

double ROBOT::ODOMETRY::UpdateVelocity(double v_now, double target_v, DWORD delta_time){
	if( v_now > target_v ){//lڕWlI[o[Ăꍇ(s)
		if( v_now-(double(delta_time)/1000.)*deceleration >= target_v ){
			return (v_now-(double(delta_time)/1000.)*deceleration);
		}
		else{
			return target_v;
		}
	}else if( v_now < target_v ){//lڕWlႢꍇ(s)
		if( v_now+(double(delta_time)/1000.)*acceleration <= target_v ){
			return (v_now+(double(delta_time)/1000.)*acceleration);
		}
		else{
			return target_v;
		}
	}else{//ڕWlƎlvĂꍇ
		return target_v;
	}
}

void ROBOT::ODOMETRY::UpdateState(double average_vl, double average_vr, DWORD delta_time){
	double delta_theta = ((average_vr - average_vl)/tread)*(double(delta_time)/1000.);
	double delta_L_dash;
	if(average_vr != average_vl){
		delta_L_dash = (tread * (average_vr + average_vl)/(average_vr - average_vl))*sin(delta_theta/2.);
	}else{
		delta_L_dash = average_vr * (double(delta_time)/1000.);
	}
	double set_theta = GetTheta()+delta_theta;
	while( set_theta > M_PI){
		set_theta -= 2.*M_PI;
	}
	while( set_theta <= -M_PI){
		set_theta += 2.*M_PI;
	}
	SetPose(GetPositionX()+delta_L_dash*cos(GetTheta() + delta_theta/2.), GetPositionY()+delta_L_dash*sin(GetTheta() + delta_theta/2.), set_theta);
}

void ROBOT::ODOMETRY::SetParameter(double tread, double acc, double dec, double InitX, double InitY, double InitTheta){
	this->tread = tread;
	this->acceleration = acc;
	this->deceleration = dec;
	SetPose(InitX, InitY, InitTheta);
}

void ROBOT::ODOMETRY::Reset(DWORD time){
	SetPose(GetInitPositionX(), GetInitPositionY(), GetInitTheta());
	SetVelocity(0, 0);
	SetReceiveVelocity(0, 0);
	this->receive_time = time;
}

void ROBOT::ODOMETRY::Update(DWORD time){
	DWORD delta_time = time - this->receive_time;
	double tmp_vl, tmp_vr;
	GetVelocity( &tmp_vl, &tmp_vr);

	/*** x̍XV ***/
	/* ^Cx̍XV */
	SetVelocityVl( UpdateVelocity( GetVelocityVl(), GetReceiveVelocityVl(), delta_time ) );
	/* E^Cx̍XV */
	SetVelocityVr( UpdateVelocity( GetVelocityVr(), GetReceiveVelocityVr(), delta_time ) );
	/* V, W̍XV */
	ConvertVLVRtoVW();

	/*** Ԃ̍XV ***/
	UpdateState( (tmp_vl+GetVelocityVl())/2., (tmp_vr+GetVelocityVr())/2., delta_time);

	/*** 擾Ԃ̍XV ***/
	this->receive_time = time;
}

void ROBOT::ODOMETRY::ControlReceive(double velocity, double omega, DWORD time){
	Update(time);
	ConvertVWtoVLVR(velocity, omega);
}
