//------------------------------------------------------------------------------------------------+
// Filename: Field.cpp
// Content : V~[VNXƂ̊֘ANX̊֐`
//------------------------------------------------------------------------------------------------+

#include "Field.h"


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define ERROR_ID	-1;		// ݒ̖ړInID


// Name: Wall() ----------------------------------------------------------------------------------+
// ̒lɉǂ̃xNgԂ
//------------------------------------------------------------------------------------------------+
Line Walls::Wall(int no){

	if( 0 <= no && (unsigned)no < walls.size() ) return walls[no];

	throw "Error: No wall data. Out of number. ( Walls::Wall() )";
}


// Name: CheckConnekt() --------------------------------------------------------------------------+
// wxNgƌǂȂtrueԂ
//------------------------------------------------------------------------------------------------+
bool Walls::CheckConnect( Line line ){

	for( unsigned int i=0; i<walls.size() ; i++ ){

		if( line.KreuzungUrteil( walls[i] ) ) return false;
	}

	return true;
}


// Name: AddWall() -------------------------------------------------------------------------------+
// ǂo^iǉj
//------------------------------------------------------------------------------------------------+
void Walls::AddWall( Line wall ){

	walls.push_back( wall );

	// ǂtB[h̑傫𒲂ׂ
	if( width  < wall.x           ) width  = wall.x;
	if( width  < wall.x + wall.dx ) width  = wall.x + wall.dx;
	if( length < wall.y           ) length = wall.y;
	if( length < wall.y + wall.dy ) length = wall.y + wall.dy;
}


// Name: DeleteWall() ----------------------------------------------------------------------------+
// noԂ̕ǂ
//------------------------------------------------------------------------------------------------+
void Walls::DeleteWall( int no ){

	if( 0 <= no && (unsigned)no < walls.size() ){

		std::vector<Line>::iterator p;
		p += no;
		p = walls.erase(p);
	}
}


// Name: Entrance()-------------------------------------------------------------------------------+
// RXgN^
//------------------------------------------------------------------------------------------------+
Entrance::Entrance( int id, Line e, double time, double sigma ){

	this->id  = id;
	this->e   = e;
	interval  = GausRand( time, sigma );
	rest_time = interval.Rand();
}


// Name: PersonEnter()----------------------------------------------------------------------------+
// oߎԂl̗LԂ
//------------------------------------------------------------------------------------------------+
bool Entrance::PersonEnter( double pass_time ){

	rest_time -= pass_time;

	if( 0.0 < rest_time ) return false;

	rest_time += interval.Rand();

	return true;
}


// Name: EnterPosition()--------------------------------------------------------------------------+
// l̓WԂ
//------------------------------------------------------------------------------------------------+
Coordinate Entrance::EnterPosition( void ){

	double p = GausRand( 0.5, 0.1 ).Rand();
	return Coordinate( e.x + p * e.dx, e.y + p * e.dy );
}


// Name: Destination()----------------------------------------------------------------------------+
//	ړInNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Destination::Destination(){

	this->id = ERROR_ID;
}


// Name: Destination()----------------------------------------------------------------------------+
//	ړInNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Destination::Destination( int id, double x, double y ){

	this->id = id;
	this->x  = x;
	this->y  = y;
}


// Name: Exit()-----------------------------------------------------------------------------------+
// oNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Exit::Exit():Destination(){

	type = DEST_EXIT;
}



// Name: Exit()-----------------------------------------------------------------------------------+
// oNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Exit::Exit( int id, Line d ):Destination( id, d.CenterX(), d.CenterY() ){

	type    = DEST_EXIT;
	this->d = d;
}


// Name: Point()----------------------------------------------------------------------------------+
// n_NX̃RXgN^
//------------------------------------------------------------------------------------------------+
Point::Point():Destination(){

	type = DEST_POINT;
}



// Name: Point()----------------------------------------------------------------------------------+
// n_NX̃RXgN^
//------------------------------------------------------------------------------------------------+
Point::Point( int id, double x, double y, double radius ):Destination( id, x, y ){

	type         = DEST_POINT;
	this->radius = radius;
}


// Name: Seat()-----------------------------------------------------------------------------------+
// ȃNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Seat::Seat():Destination(){

	type = DEST_SEAT;
}


// Name: Seat()-----------------------------------------------------------------------------------+
// ȃNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Seat::Seat( int id, double x, double y ):Destination( id, x, y ){

	type = DEST_SEAT;
}


// Name: Queue()----------------------------------------------------------------------------------+
//	sNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Queue::Queue():Destination(){

	type = DEST_QUEUE;
}


// Name: Queue()----------------------------------------------------------------------------------+
//	sNX̃RXgN^
//------------------------------------------------------------------------------------------------+
Queue::Queue( int id, Line p ):Destination( id, p.x, p.y ){

	type    = DEST_QUEUE;
	this->p = p;
}
