//------------------------------------------------------------------------------------------------+
// Filename: Field.h
// Content : V~[VNXƂ̊֘ANX̒`
//------------------------------------------------------------------------------------------------+
#ifndef __FIELD
#define __FIELD

#include "applib.h"
#include <vector>


//------------------------------------------------------------------------------------------------+
// ړIn̎ނ񋓌^̒`
//------------------------------------------------------------------------------------------------+
enum DestType{

	DEST_EXIT,
	DEST_POINT,
	DEST_SEAT,
	DEST_QUEUE
};


//------------------------------------------------------------------------------------------------+
// ǃNX̒`
//------------------------------------------------------------------------------------------------+
class Walls{

	double width, length;				// Ԃ̑傫
	std::vector<Line> walls;			// ǃf[^i[Rei

public:
	Walls(){ width = length = 0.0; }					// RXgN^
	int WallNum(){ return (int)walls.size(); }			// ǂ̑Ԃ
	double FieldWidth(){ return width; };				// tB[h̕(x)Ԃ
	double FieldLength(){ return length; };				// tB[h̒(y)Ԃ
	std::vector<Line> SegmentsData(){ return walls; }	// ǂ̐f[^Ԃ

	Line Wall( int no );				// noԂ̕ǃxNgԂ
	bool CheckConnect( Line line );		// wƌǂȂtrueԂ
	void AddWall( Line wall );			// ǂo^iǉj
	void DeleteWall( int no );			// noԂ̕ǂ
};


//------------------------------------------------------------------------------------------------+
// NX̒`
//------------------------------------------------------------------------------------------------+
class Entrance{

	int id;					// ID
	Line e;					// ŕ\
	GausRand interval;		// Ԋu̗
	double rest_time;		// ̐lꂷ܂ł̎c莞

public:
	Entrance( int id, Line e, double time, double sigma );	// RXgN^

	int ID(){ return id; }						// IDԂ
	bool PersonEnter( double pass_time );		// oߎԂl̗̓LԂ
	Coordinate EnterPosition();					// l̓WԂ
	Line EntranceLine(){ return e; }			// f[^Ԃ
};


//------------------------------------------------------------------------------------------------+
// ǗNX̒`
//------------------------------------------------------------------------------------------------+
class Entrances{

	std::vector<Entrance> ent_vec;

public:

	// oߎԂnoԂ̓̐l̗̓LԂ
	bool PersonEnter( int no, double pass_time ){
		if( 0 <= no && no < EntranceNum() ) return ent_vec[no].PersonEnter( pass_time );
		return false;
	}

	int EntranceID( int no ){ return ent_vec[no].ID(); }						// noԂ̓IDԂ
	Coordinate EnterPosition( int no ){ return ent_vec[no].EnterPosition(); }	// noԂ̓̓WԂ
	Line EntranceLine( int no ){ return ent_vec[no].EntranceLine(); }			// noԂ̓Ԃ
	int EntranceNum(){ return (int)ent_vec.size(); }							// f[^Ԃ
	void AddEntrance( Entrance ent_data ){ ent_vec.push_back( ent_data ); }		// f[^ǉ
};


//------------------------------------------------------------------------------------------------+
// ړInNXiۃNXj
//------------------------------------------------------------------------------------------------+
class Destination{

protected:
	DestType type;		// ړIn̕
	int id;				// ړInID
	double x, y;		// ړIn̒SW

public:
	Destination();
	Destination( int id, double x, double y );
	virtual ~Destination(){}

	DestType Type(){ return type; }		// ړIn̎ނԂ
	int ID(){ return id; }				// ړInIDԂ
	double GetX(){ return x; }			// ړInXWԂ
	double GetY(){ return y; }			// ړInZWԂ
};


//------------------------------------------------------------------------------------------------+
// oNX
//------------------------------------------------------------------------------------------------+
class Exit :public virtual Destination{

	Line d;		// ړInƂȂ

public:
	Exit();
	Exit( int id, Line d );

	~Exit(){}
	Line GetExit(){ return d; }		// ړInƂȂԂ
};


//------------------------------------------------------------------------------------------------+
// n_NX
//------------------------------------------------------------------------------------------------+
class Point :public virtual Destination{

	double radius;		// a

public:
	Point();
	Point( int id, double x, double y, double radius );
	~Point(){};

	double Radius(void){ return radius; }		// ړIn͈̔́iajԂ
};


//------------------------------------------------------------------------------------------------+
// ȃNX
//------------------------------------------------------------------------------------------------+
class Seat :public virtual Destination{

	double x, y;		// ړIn̍W

public:
	Seat();
	Seat( int id, double x, double y );
	~Seat(){};
};


//------------------------------------------------------------------------------------------------+
// sNX
//------------------------------------------------------------------------------------------------+
class Queue :public virtual Destination{

	Line p;		// ړIn̍Wƍs񐶐

public:
	Queue();
	Queue( int id, Line p );
	~Queue(){};

	Line Data(void){ return p; }		// ړIn̍Wƍs񐶐̗LԂ

};


//------------------------------------------------------------------------------------------------+
// IDtf[^ǗNX̒`iړInǗpj
// f[^IDŊǗ
// ID̃f[^݂Ăǂ
//------------------------------------------------------------------------------------------------+
template <typename T> class DataMng{

	std::vector<T> data;						// ړInf[^i[
	std::vector< std::vector<int> > data_id;	// ړInIDƔԍ̑Ή\

public:
	int DataNum(){ return (int)data.size(); }	// f[^Ԃ

	// noԂ̃f[^Ԃ
	T GetData( int no ){

		if( 0 <= no && no < (int)data.size() ) return data[no];
		T dummy;
		return dummy;
	}

	// w肳ꂽidnoԖڂ̃f[^ԍԂ
	int GetDataNo( int id, int no ){

		if( 0 <= id && id < (int)data_id.size() && 0 <= no && no < (int)data_id[id].size() ){
			return data_id[id][no];
		}
		return -1;	// error
	}

	// w肳ꂽidnoԖڂ̃f[^Ԃ
	T GetData( int id, int no ){ return GetData( GetDataNo( id, no ) ); }

	// w肳ꂽid̃f[^Ԃ
	int DataNum( int id ){

		if( id < 0 || (int)data_id.size() <= id ) return 0;
		return (int)data_id[id].size();
	}

	// f[^ǉ
	void AddData( int id, T new_data ){

		if( id < 0 ) return;
		data.push_back( new_data );
		data_id.resize( id + 1 );
		data_id[ id ].push_back( DataNum() - 1 );
	}
};


//------------------------------------------------------------------------------------------------+
// NX̒`
//------------------------------------------------------------------------------------------------+
class Field : public Walls, public Entrances {

public:
	DataMng<Exit>  exits;
	DataMng<Point> points;
	DataMng<Seat>  seats;
	DataMng<Queue> queues;

//	Field(){}		// RXgN^

};

#endif	//__FIELD
