//------------------------------------------------------------------------------------------------+
// Filename: FieldFactory.cpp
// Content : tB[h\zNX̊֐`
//------------------------------------------------------------------------------------------------+
#include <iostream>
#include <fstream>
#include <cstring>
#include "Factory.h"
#include "applib.h"

using namespace std;


/************************************** g[N̓NX ***************************************/

// Name: TokenAnalysis() -------------------------------------------------------------------------+
// RXgN^
// t@Cf[^ǂݍŃg[NƂĊi[
//------------------------------------------------------------------------------------------------+
TokenAnalysis::TokenAnalysis( const char *filename ){

	ifstream fin;
	Token tok;

	fin.open( filename );

	if( !fin ){
		cerr << "Error! File \"" << filename << "\" could not open.\n";
		return;
	}

	// t@CǂݍŃg[NXgɓĂ
	for( int i=0; fin.get(tok.num.str[i]); ){

		if( i == 0 && ( tok.num.str[0] <= ' ' || tok.num.str[0] == '\t' || tok.num.str[0] == '\n' )) continue;

		// Rgǂݔ΂
		if( tok.num.str[i] == '#' ){
			char ch;
			while( fin.get(ch) && ch != '\n' );
			continue;
		}

		tok.num.str[i+1] = '\0';

		if(      i == 0 && tok.num.str[0] == '{' ) tok.type = T_ARC_LEFT;
		else if( i == 0 && tok.num.str[0] == '}' ) tok.type = T_ARC_RIGHT;
		else if( i == 0 && tok.num.str[0] == ',' ) tok.type = T_CORON;
		else if( i == 0 && tok.num.str[0] == ';' ) tok.type = T_SEMICORON;
		else if( tok.num.str[i] == '{' ){

			tok.num.str[i] = '\0';
			PushNumToken( tok );
			tok.type = T_ARC_LEFT;
		}

		else if( tok.num.str[i] == '}' ){

			tok.num.str[i] = '\0';
			PushNumToken( tok );
			tok.type = T_ARC_LEFT;
		}
		
		else if( tok.num.str[i] == ',' ){

			tok.num.str[i] = '\0';
			PushNumToken( tok );
			tok.type = T_CORON;
		}

		else if( tok.num.str[i] == ';' ){

			tok.num.str[i] = '\0';
			PushNumToken( tok );
			tok.type = T_SEMICORON;
		}

		else if( tok.num.str[i] == ' ' || tok.num.str[i] == '\t' || tok.num.str[i] == '\n' ){

			tok.num.str[i] = '\0';
			PushNumToken( tok );
			i = 0;
			continue;
		}
		else{		// ܂̓r
			i++;
			continue;
		}

		token_list.push_back(tok);
		i = 0;
	}

	fin.close();
}


// Name: PushNumToken() --------------------------------------------------------------------------+
// lłg[No^
//------------------------------------------------------------------------------------------------+
bool TokenAnalysis::PushNumToken( Token tok ){

	if( CheckInteger(tok.num.str) ){
		tok.num.d = (double)atoi( tok.num.str );
		tok.type = T_NUMBER;
		token_list.push_back(tok);
	}
	if( CheckDouble(tok.num.str) ){
		tok.num.d = atof( tok.num.str );
		tok.type = T_NUMBER;
		token_list.push_back(tok);
	}
	else if( CheckString(tok.num.str) ){
		tok.type = T_STRING;
		token_list.push_back(tok);
	}
	else return false;
	return true;
}


// Name: ReadNumber() ----------------------------------------------------------------------------+
// g[NXgZ~R܂Œlǂň̃XgɈڂ
//------------------------------------------------------------------------------------------------+
bool TokenAnalysis::ReadNumber( list<TokenNum>& num_list ){

	while(1){

		TokenNum num;

		if( token_list.front().type == T_NUMBER || token_list.front().type == T_STRING ){

			num = token_list.front().num;
		}
		else{
			cerr << "Error! Data could not create.\n";
			cerr << "       " << token_list.front().num.str << "is not number.\n";
			return false;
		}

		num_list.push_back( num );

		token_list.pop_front();

		if( token_list.front().type == T_CORON ){

			token_list.pop_front();
			continue;
		}
		if( token_list.front().type == T_SEMICORON ){

			token_list.pop_front();
			break;
		}

		cerr << "Error! Data could not create.\n";
		cerr << "       Need \',\' or \';\' at number's back.\n";
		return false;
	}

	return true;
}


/************************************* tB[h\zNX **************************************/

// Name: FieldFactory() --------------------------------------------------------------------------+
// RXgN^
//------------------------------------------------------------------------------------------------+
FieldFactory::FieldFactory( const char *filename ){

	cerr << "\nStart to load environment data.\n";

	token = new TokenAnalysis( filename );

	if( NewDataCreate() ){

		cerr << endl;
		cerr << " Walls              : " << field.WallNum()        << endl;
		cerr << " Entrances          : " << field.EntranceNum()    << endl;
		cerr << " Destination Exits  : " << field.exits.DataNum()  << endl;
		cerr << " Destination Points : " << field.points.DataNum() << endl;
		cerr << " Destination Seats  : " << field.seats.DataNum()  << endl;
		cerr << " Destination Queues : " << field.queues.DataNum() << endl;
		cerr << " Actions            : " << act_mng.ActionNum()    << endl;

//		if( subareas.size() == 0 ) {
//				GenerateSubareas generatesubareas( &field );
//				subareas = generatesubareas.subareas;
//		}
//		cerr << " Subareas           : " << subareas.size()		  << endl << endl;
	}

	delete token;
	token = 0;
}


// Name: NewDataCreate() -------------------------------------------------------------------------+
// g[Nevfo^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewDataCreate(){

	while( !token->token_list.empty() ){

		// ǃf[^
		if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "Walls" ) == 0 ){

			token->token_list.pop_front();

			if( token->token_list.front().type==TokenAnalysis::T_ARC_LEFT){

				token->token_list.pop_front();

				while( token->token_list.front().type != TokenAnalysis::T_ARC_RIGHT ) if( !NewWall() ) return false;

				token->token_list.pop_front();
			}
			else if( !NewWall() ) return false;
		}

		// f[^
		else if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "Entrance" ) == 0 ){

			token->token_list.pop_front();

			if( token->token_list.front().type==TokenAnalysis::T_ARC_LEFT){

				token->token_list.pop_front();

				while( token->token_list.front().type != TokenAnalysis::T_ARC_RIGHT ) if( !NewEntrance() ) return false;

				token->token_list.pop_front();
			}
			else if( !NewEntrance() ) return false;
		}

		// ړInf[^
		else if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "Destination" ) == 0 ){

			token->token_list.pop_front();

			if( token->token_list.front().type==TokenAnalysis::T_ARC_LEFT){

				token->token_list.pop_front();

				while( token->token_list.front().type != TokenAnalysis::T_ARC_RIGHT ) if( !NewDestination() ) return false;

				token->token_list.pop_front();
			}
			else if( !NewDestination() ) return false;
		}

		// ŏ̍sf[^
		else if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "FirstActions" ) == 0 ){

			token->token_list.pop_front();
			if( !NewFirstActions() ) return false;
		}

		// sf[^
		else if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "Actions" ) == 0 ){

			token->token_list.pop_front();

			if( token->token_list.front().type==TokenAnalysis::T_ARC_LEFT){

				token->token_list.pop_front();

				while( token->token_list.front().type != TokenAnalysis::T_ARC_RIGHT ) if( !NewAction() ) return false;

				token->token_list.pop_front();
			}
			else if( !NewAction() ) return false;
		}

		// TuGAf[^
		else if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "SubArea" ) == 0 ){

			token->token_list.pop_front();

			if( token->token_list.front().type==TokenAnalysis::T_ARC_LEFT){

				token->token_list.pop_front();

				while( token->token_list.front().type != TokenAnalysis::T_ARC_RIGHT ) if( !NewSubArea() ) return false;

				token->token_list.pop_front();
			}
			else if( !NewSubArea() ) return false;
		}

		// TuGÃNf[^
		else if( token->token_list.front().type == TokenAnalysis::T_STRING && strcmp( token->token_list.front().num.str, "AreaLink" ) == 0 ){

			token->token_list.pop_front();

			if( token->token_list.front().type==TokenAnalysis::T_ARC_LEFT){

				token->token_list.pop_front();

				while( token->token_list.front().type != TokenAnalysis::T_ARC_RIGHT ) if( !NewAreaLink() ) return false;

				token->token_list.pop_front();
			}
			else if( !NewAreaLink() ) return false;
		}

		else{
			cerr << "Error! Data format error!\n";
			return false;
		}
	}

	RegistAreaLink();
	return true;
}


// Name: NewWall() -------------------------------------------------------------------------------+
// g[NVǃf[^o^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewWall(){

	const int wall_data_num = 4;

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	if( num_list.size() != wall_data_num ){

		cerr << "Error! Wall data could not create.\n";
		cerr << "       Data number error.\n";
		return false;
	}

	double num[wall_data_num];

	for( int i=0; i<wall_data_num; i++ ){

		num[i] = num_list.front().d;
		num_list.pop_front();
	}

	field.AddWall( Line( num[0], num[1], num[2]-num[0], num[3]-num[1] ));
	return true;
}


// Name: NewEntrance() ---------------------------------------------------------------------------+
// g[NVf[^o^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewEntrance(){

	const int entrance_data_num = 7;

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	if( num_list.size() != entrance_data_num ){

		cerr << "Error! Entrance data could not create.\n";
		cerr << "       Data number error.\n";
		return false;
	}

	double num[entrance_data_num];

	for( int i=0; i<entrance_data_num; i++ ){

		num[i] = num_list.front().d;
		num_list.pop_front();
	}

	field.AddEntrance( Entrance( (int)num[0], Line( num[1], num[2], num[3]-num[1], num[4]-num[2] ), num[5], num[6] ));
	return true;
}


// Name: NewDestination() ------------------------------------------------------------------------+
// g[NVړInf[^o^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewDestination(){

	const int dest_type_num  = 4,
			  dest_data_max  = 5,
			  dest_data_num[] = { 5, 4, 3, 5 };

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	if( num_list.front().str[1] != '\0' ){

		cerr << "Error! Destination data could not create.\n";
		cerr << "       Destination type error(" << num_list.front().str << ").\n";
		return false;
	}

	char type_ch = num_list.front().str[0];

	num_list.pop_front();

	int type;

	if(      type_ch == 'X' || type_ch == 'x' ) type = 0;
	else if( type_ch == 'P' || type_ch == 'p' ) type = 1;
	else if( type_ch == 'S' || type_ch == 's' ) type = 2;
	else if( type_ch == 'Q' || type_ch == 'q' ) type = 3;
	else{
		cerr << "Error! Destination data could not create.\n";
		cerr << "       Destination type error(" << type_ch << ").\n";
		return false;
	}

	if( num_list.size() != dest_data_num[type] ){

		cerr << "Error! Destination data could not create.\n";
		cerr << "       Data number error.\n";
		return false;
	}

	double num[dest_data_max];

	for( int i=0; i<dest_data_num[type]; i++ ){

		num[i] = num_list.front().d;
		num_list.pop_front();
	}

	if( type == 0 ) field.exits.AddData(  (int)num[0], Exit(  (int)num[0], Line( num[1], num[2], num[3]-num[1], num[4]-num[2] )));
	if( type == 1 ) field.points.AddData( (int)num[0], Point( (int)num[0], num[1], num[2], num[3] ));
	if( type == 2 ) field.seats.AddData(  (int)num[0], Seat(  (int)num[0], num[1], num[2] ));
	if( type == 3 ) field.queues.AddData( (int)num[0], Queue( (int)num[0], Line( num[1], num[2], num[3], num[4] )));

	return true;
}


// Name: NewAction()------------------------------------------------------------------------------+
// g[Nsf[^o^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewAction(){

	const int data_num = 4;

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	// sID
	int id = (int)num_list.front().d;
	num_list.pop_front();

	// s̎
	if( num_list.front().str[1] != '\0' ){

		cerr << "Error! Action data could not create.\n";
		cerr << "       Action type error(" << num_list.front().str << ").\n";
		return false;
	}

	char type_ch = num_list.front().str[0];

	ActionType type;

	if(      type_ch == 'X' || type_ch == 'x' ) type = GOTO_EXIT;
	else if( type_ch == 'P' || type_ch == 'p' ) type = GOTO_POINT;
	else if( type_ch == 'S' || type_ch == 's' ) type = GOTO_SEAT;
	else if( type_ch == 'Q' || type_ch == 'q' ) type = GOTO_QUEUE;
	else{
		cerr << "Error! Action data could not create.\n";
		cerr << "       Action type error(" << type_ch << ").\n";
		return false;
	}
	num_list.pop_front();

	if( num_list.size() != data_num ){

		cerr << "Error! Action data could not create.\n";
		cerr << "       Data number error.\n";
		return false;
	}

	double num[data_num];

	for( int i=0; i<data_num; i++ ){

		num[i] = num_list.front().d;
		num_list.pop_front();
	}

	act_mng.AddAction( id, Action( type, (int)num[0], (int)num[1], num[2], num[3] ));
	return true;
}


// Name: NewFirstActions()------------------------------------------------------------------------+
// g[Nŏ̍sf[^o^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewFirstActions(){

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	while( !num_list.empty() ){

		act_mng.AddFirstAction( (int)num_list.front().d );
		num_list.pop_front();
	}

	return true;
}


// Name: NewSubArea() ----------------------------------------------------------------------------+
// g[NTuGAf[^o^
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewSubArea(){

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	// f[^͊̂͂
	if( num_list.size()%2 == 0 ){

		cerr << "Error! Subarea data could not create.\n";
		cerr << "       Data number error.\n";
		return false;
	}

	int id = (int)num_list.front().d;
	num_list.pop_front();

	const int data_num = num_list.size() / 2;

	vector<Coordinate> apexes;

	for( int i=0; i<data_num; i++ ){

		Coordinate c;

		c.x = num_list.front().d;
		num_list.pop_front();
		c.y = num_list.front().d;
		num_list.pop_front();

		apexes.push_back( c );
	}

	if( id < 0 ) return false;
	if( (int)subareas.size() < id+1 ) subareas.resize( id+1 );
	subareas[id] = SubArea( id, apexes );
	return true;
}


// Name: NewAreaLink() ---------------------------------------------------------------------------+
// g[NTuGÃNf[^𐶐
//------------------------------------------------------------------------------------------------+
bool FieldFactory::NewAreaLink(){

	const int data_num = 6;

	list<TokenAnalysis::TokenNum> num_list;

	if( !token->ReadNumber( num_list )) return false;

	if( num_list.size() != data_num ){

		cerr << "Error! AreaLink data could not create.\n";
		cerr << "       Data number error.\n";
		return false;
	}

	double num[data_num];

	for( int i=0; i<data_num; i++ ){

		num[i] = num_list.front().d;
		num_list.pop_front();
	}

	links.push_back( AreaLink( (int)num[0], (int)num[1], Line( num[2], num[3], num[4]-num[2], num[5]-num[3] )));
	return true;
}


// Name: RegistAreaLink() ------------------------------------------------------------------------+
// TuGÃNf[^TuGAɓo^
//------------------------------------------------------------------------------------------------+
void FieldFactory::RegistAreaLink(){

	while( !links.empty() ){
		subareas[links.front().id1].AddLink( links.front().id2, links.front().line );
		subareas[links.front().id2].AddLink( links.front().id1, links.front().line );
		links.pop_front();
	}
}
