//------------------------------------------------------------------------------------------------+
// Filename: Network.h
// Content : ړlbg[N֘ANX̒`
//------------------------------------------------------------------------------------------------+
#ifndef __NETWORK
#define __NETWORK

#include "Field.h"
#include <vector>
#include <list>

using namespace std;


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define VOID_SUBAREA_ID	 -1		// TuGAID


//------------------------------------------------------------------------------------------------+
// TuGANX̒`
//------------------------------------------------------------------------------------------------+
class SubArea :public virtual Polygon{

	// TuGAǂ̃NNX
	class Link{
	public:
		int id;			// ÑTuGAID
		Line boder;		// GA̋E

		Link( int id, Line line ){
			this->id = id;
			boder    = line;
		}
	};

	int id;				// TuGAID
	vector<Link> links;	// N

public:
	int population;		// TuGA̐l

	SubArea(){ id = VOID_SUBAREA_ID; }
	SubArea( int id, Vertexes apexes ):Polygon( apexes ){ this->id = id; population = 0; }

	bool CheckConnect( int id );						// w肵TuGAƐڂĂtrueԂ
	bool CheckConnect( SubArea area );					// w肵TuGAƐڂĂtrueԂ
	Line Border( int area_id );							// w肵TuGAƐڂĂ΂̋EԂ
	Line Border( SubArea area );						// w肵TuGAƐڂĂ΂̋EԂ
	double Distance( int id1, int id2 );				// w肵QTuGAƐڂĂ΂̊ԊuԂ
	double Distance(  SubArea area1,  SubArea area2 );	// w肵QTuGAƐڂĂ΂̊ԊuԂ
	vector<int> ConnectedAreaIDs();						// ڂĂGAIDnԂ

	int ID(){ return id; }
	void AddLink( int id, Line line ){ links.push_back( Link( id, line )); }		// No^
	double Density(){ return (double)population / Square(); }						// l̖x
};


//------------------------------------------------------------------------------------------------+
// oH̒`
//------------------------------------------------------------------------------------------------+
typedef list<SubArea> Path;


//------------------------------------------------------------------------------------------------+
// TuGȀW̒`
//------------------------------------------------------------------------------------------------+
typedef vector<SubArea> SubAreas;


//------------------------------------------------------------------------------------------------+
// RXgťoHf[^
//------------------------------------------------------------------------------------------------+
class PathCost{
public:
	Path path;
	double cost;
};


//------------------------------------------------------------------------------------------------+
// ړlbg[NNX̒`
//------------------------------------------------------------------------------------------------+
class Network{

	// oHTp̃f[^NX
	class Data{
	public:
		class List{
		public:
			bool open, close;
			double cost, heur;
			int next;
		};
		int start, goal;
		vector<List> lst;
		list<int> sorted_open;

		Data( int size, int start_no, int goal_no );
		int MinScore();					// I[vXgŏXRÃm[h̓YԂ
		void AddOpen( int no );			// I[vXgɃm[h
	};

public:
	SubAreas subareas;

	Network(){}
	Network( SubAreas subareas ){ this->subareas = subareas; }

	PathCost PathFinding( Coordinate start, Coordinate goal );		// (sx,sy)(gx,gy)ւ̌oHvZ

	int SubAreaNo( Coordinate pos );		// WTuGAz̓YԂ
	int SubAreaID( Coordinate pos );		// WTuGAIDԂ
	SubArea GetSubArea( Coordinate pos );	// WTuGAԂ
	void AddPopulation( Coordinate c );		// wW̃TuGA̐lZ
	void ResetPopulation();					// STuGA̐lOɂ

private:
	Data InitList( Coordinate start, Coordinate goal );		// Xg𐶐
	PathCost GeneratePath( Data lst );						// XgoH𐶐
};


//------------------------------------------------------------------------------------------------+
// TuGÅǗEœK
//------------------------------------------------------------------------------------------------+
class SubAreasManager{

	SubAreas subareas;

public:
	SubAreasManager( SubAreas subareas ){ this->subareas = subareas; }

	SubAreas ExtractInside( Coordinate inside );
//	SubAreas Cutdouwn( double threshold );

private:
	SubAreas Reconstruction( vector<bool> keep );
};


#endif	//__NETWORK
