//------------------------------------------------------------------------------------------------+
// Filename: People.h
// Content : lE{bg֘ANX̒`
//------------------------------------------------------------------------------------------------+
#ifndef __PEOPLE
#define __PEOPLE

#include "Network.h"
#include "applib.h"
#include <vector>
#include <list>


//------------------------------------------------------------------------------------------------+
// s̎ނ񋓌^̒`
//------------------------------------------------------------------------------------------------+
enum ActionType{

	GOTO_EXIT,
	GOTO_POINT,
	GOTO_SEAT,
	GOTO_QUEUE,
	NO_ACTION
};


//------------------------------------------------------------------------------------------------+
// sNX̒`
//------------------------------------------------------------------------------------------------+
class Action{

private:
	ActionType type;		// s̎
	int dest_id;			// ړInID
	int next;				// ɍssID
	GausRand wait;			// ҋ@

public:
	int dest_no;			// ړInԍ

	Action(){ type = NO_ACTION; }

	Action( ActionType type, int dest_id, int next, double wait_time, double wait_sigma ){
		this->type    = type;
		this->dest_id = dest_id;
		this->next    = next;
		wait          = GausRand( wait_time, wait_sigma );
		dest_no       = 0;
	}

	ActionType Type(){ return type; }				// s̎ނԂ
	int DestID(){ return dest_id; }					// ړInIDԂ
	int Next(){ return next; }						// ɍssIDԂ
	double WaitTime(){ return wait.Rand(); }		// ҋ@ԂvZĕԂ
	double WaitTimeMean(){ return wait.mean; }		// ҋ@Ԃ̕ςԂ
};


//------------------------------------------------------------------------------------------------+
// sǗNX̒`
//------------------------------------------------------------------------------------------------+
class ActionMng{

	std::vector<Action> actions;
	std::vector<int> firsts;

public:
	Action FirstAction( int ent_id ){ return actions[firsts[ent_id]]; }		// ɉŏ̍sԂ
	Action GetAction( int action_id ){ return actions[action_id]; }			// w肳ꂽid̍sԂ
	Action NextAction( Action act ){ return actions[act.Next()]; }			// w肳ꂽs玟̍sԂ
	int ActionNum(){ return (int)actions.size(); }							// sf[^Ԃ
	void AddFirstAction( int id ){ firsts.push_back(id); }					// ŏ̍sIDǉ


	// sf[^ǉ
	void AddAction( int id, Action data ){

		actions.resize( id + 1 );
		actions[id]= data;
	}
};


//------------------------------------------------------------------------------------------------+
// lNX̒`
//------------------------------------------------------------------------------------------------+
class Person{

	int id;					// lʂŗLID
	double walk_speed;		// Rsx

public:
	Line p;					// WƃxNg
	Path path;				// oH
	Action action;			// sf[^
	double wait_time;		// cҋ@

	// RXgN^
	Person( int id, double speed ){
		this->id   = id;
		walk_speed = speed;
		wait_time  = 0.0;
	}

	int ID(){ return id; }						// lʂŗLIDԂ
	double WalkSpeed(){ return walk_speed; }	// sxԂ
};


//------------------------------------------------------------------------------------------------+
// lX̒`
//------------------------------------------------------------------------------------------------+
typedef std::vector<Person> People;


//------------------------------------------------------------------------------------------------+
// {bgNX̒`
//------------------------------------------------------------------------------------------------+
class Robot :public Coordinate{
public:
	double theta;

	// RXgN^
	Robot(){ theta=0.0; }
	Robot( double x, double y, double theta ): Coordinate( x, y ){ this->theta = theta; }
};


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define DEFAULT_MAP_WIDTH		200			// {bgpn}̔z̓Y
#define DEFAULT_MAP_HEIGHT		200			// {bgpn}̔z̓Y
#define DEFAULT_CELL_SIZE		0.05		// 쐬n}1Z̏c̑傫̃ftHgl[m]


//------------------------------------------------------------------------------------------------+
// {bgpn}NX̒`
//------------------------------------------------------------------------------------------------+
class RoboMap{

	int width, height;
	double scale;
	std::vector<Line> walls;		// Wϊ̕ǃf[^i[

public:
	vector<vector<unsigned char>> map;

	// RXgN^
	RoboMap( int width=DEFAULT_MAP_WIDTH, int heigh=DEFAULT_MAP_HEIGHT, double scale=DEFAULT_CELL_SIZE );

	void MakeMap( Walls *wall_data, Robot *robot );				// {bgpn}𐶐
	Coordinate Convert( Coordinate c, Robot *robot );			// W{bgWnɕϊ
	Line Convert( Line line, Robot *robot );					// ̍Wϊ

private:
	void Convert( Walls *wall_data, Robot *robot );			// ǂ̍Wϊ
	void SetWall( Line w );									// n}ɕǂ`
	void SetCell( double x, double y );						// n}̎wWÎ~ɐݒ
};


#endif	//__PEOPLE
