//------------------------------------------------------------------------------------------------+
// Filename: Robot.cpp
// Content : {bgpn}NX̊֐`
//------------------------------------------------------------------------------------------------+

#include "People.h"
#include "applib.h"
#include <cstdio>
#include <cmath>

using namespace std;


//------------------------------------------------------------------------------------------------+
// n}̗̈m
//------------------------------------------------------------------------------------------------+
RoboMap::RoboMap( int width, int height, double scale ){

	this->width  = width;
	this->height = height;
	this->scale  = scale;

	map.resize( height );

	for( int i=0; i<height; i++ ) map[i].resize( width );
}


//------------------------------------------------------------------------------------------------+
// {bgpn}𐶐
//------------------------------------------------------------------------------------------------+
void RoboMap::MakeMap( Walls *wall_data, Robot *robot ){

	if( !wall_data || !robot ) return;

	*this = RoboMap( width, height, scale );
	Convert( wall_data, robot );
	for( int i=0; i< (int)walls.size(); i++ ) SetWall( walls[i] );
}


//------------------------------------------------------------------------------------------------+
// WWn烍{bgWnɕϊ
//------------------------------------------------------------------------------------------------+
Coordinate RoboMap::Convert( Coordinate c, Robot *robot ){

	if( !robot ) return c;

	double theta;

	c.x  -= robot->x;
	c.y  -= robot->y;
	theta = robot->theta;

	return Coordinate( c.x * cos( theta ) + c.y * sin( theta ), -c.x * sin( theta ) + c.y * cos( theta ));
}


//------------------------------------------------------------------------------------------------+
// ̍Wϊ
//------------------------------------------------------------------------------------------------+
Line RoboMap::Convert( Line line, Robot *robot ){

	if( !robot ) return line;

	Coordinate from = Coordinate( line.x, line.y );
	line.Reverse();
	Coordinate to   = Coordinate( line.x, line.y );

	return Line( Convert( from, robot ), Convert( to, robot ));
}


//------------------------------------------------------------------------------------------------+
// ǂ̍Wϊ
//------------------------------------------------------------------------------------------------+
void RoboMap::Convert( Walls *wall_data, Robot *robot ){

	if( !wall_data || !robot ) return;

	for(int i=0; i<wall_data->WallNum(); i++) walls.push_back( Convert( wall_data->Wall(i), robot ));
}


//------------------------------------------------------------------------------------------------+
// n}ɕǂ`
//------------------------------------------------------------------------------------------------+
void RoboMap::SetWall( Line w ){

	Line v = w;
	v.Normalize();
	v *= scale / 2.0;

	for( int i=0; i< 2*(int)( w.Length() / scale ); i++){
		
		SetCell( v.x, v.y );
		v.x += v.dx;
		v.y += v.dy; 
	}
}


//------------------------------------------------------------------------------------------------+
// n}̎wWÎ~ɐݒ
//------------------------------------------------------------------------------------------------+
void RoboMap::SetCell( double x, double y ){


	int cell_x = (int)(( x + scale * (double)( width  / 2 )) / scale );
	int cell_y = (int)(( y + scale * (double)( height / 2 )) / scale );

	// ͈͊O̍W̏ꍇ
	if( cell_x < 0 || cell_y < 0 || width <= cell_x || height <= cell_y ) return;

	map[cell_y][cell_x] = 1;
}
