//------------------------------------------------------------------------------------------------+
// Filename: Simulator.h
// Content : V~[^NX̒`
//------------------------------------------------------------------------------------------------+
#ifndef __SIMULATOR
#define __SIMULATOR

#include "Field.h"
#include "People.h"
#include "Network.h"
#include <vector>
#include <list>


//------------------------------------------------------------------------------------------------+
// }N̒`
//------------------------------------------------------------------------------------------------+
#define DEF_MEAN_SPEED		1.33		// l̕ϕsx[m/s]̃ftHgl
#define DEF_SIGMA_SPEED		0.1			// l̕sx̕W΍̃ftHgl


//------------------------------------------------------------------------------------------------+
// V~[^NX̒`
//------------------------------------------------------------------------------------------------+
class Simulator{

	class SeatMng{ public: bool sitting; int id; };

	int person_id;
	double mean_speed, sigma_speed;
	Field *field;
	ActionMng *actions;
	People people;
	Network network;
	std::vector<SeatMng> seats_mng;			// Ȃ̋󂫏󋵂Ǘ
	std::vector<std::list<int>> queue_mng;	// `ꂽsǗ

public:
	std::vector<Robot> robots;				// {bgf[^

	Simulator( Field *field, ActionMng *action_mng, SubAreas subareas, double walkingrate=DEF_MEAN_SPEED, double walkingrate_dev=DEF_SIGMA_SPEED );	// RXgN^

	void Simulation( double pass_time );				// pass_timebԂ̐lX̓Č
	People GetPeople(){ return people; }				// lXf[^Ԃ

private:
	People Moving( double pass_time );					// pass_timeb̐lXf[^Ԃ
	void EraseOutside();								// ͈͊O̐lł
	void PeopleEnter( double pass_time );				// l̓
	bool ReachDestination( Person p );					// ړInB
	bool ReachExit( Person p );							// ړIniojB
	bool ReachPoint( Person p );						// ړInin_jB
	bool ReachSeat( Person p );							// ړIni  jB
	bool ReachQueue( Person p );						// ړInisjB
	bool ReachWaypoint( Person p );						// ԖړInB
	Person RoutePlanning( Person p );					// ړIn̑IƌoHv
	Person Potential( Person p, People predict );		// |eV@ɐlX̑xxNgXV
	double WalkingRate( Person p, People predict );		// w肵l̕sxvZ
	Vector2D DestinationPotential( Person p );			// ړInւ̃|eVԂ
	Vector2D ToDestination( Person p );					// ړInւ̃xNgԂ
	Vector2D NextDestPotential( Person p, Path path );	// Xɐ̖ړInւ̂̃|eVԂ
	Vector2D WallsPotential( Coordinate c );			// wWł̕ǂ̃|eVԂ
	Vector2D PersonPotential( Line p, Coordinate c, double q );		// lpɑ΂wW̐l̃|eVԂ
	void CheckSeatsFree();								// eȂ󂢂Ă邩𒲂ׂ
	int PersonNo( int id );								// ID炻̐l̓YԂ
	Coordinate QueueLast( int id, int no );				// ws̍ŌWԂ
	Coordinate QueuePosition( Person p );				// ړIn̍s̖ڎwׂWԂ
	Line ToQueue( Person p );							// ړIn̍sւ̃xNgԂ
	void OutQueue( Person p );							// w肵l񂩂
};

#endif	//__SIMULATOR
